-- Projeto: la_fundamental
--
-- Ao clicar no botão ENA, inicia som,
--	ao despressionar, termina.
--
--  Por:  Bolsista Ernani Rodrigues de SThiago,
--			 em março de 2013.
--        Instituto Federal Santa Catarina /DAMM
--        Florianópolis /SC
---------------- Bibliotecas ---------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
---------------- Entidade ------------------------
entity la_fundamental is 

	  generic
	  (
			FATOR:integer:=27273
	  );
	  
    port
    (
        -- Sinais de Entrada: 
        ENA,CLK,RST	: in std_logic;
		  -- Sinais de Saída:
		  BUZR			: out std_logic
     );
 
end entity la_fundamental;
---------------- Arquitetura --------------------
architecture COMPORTAMENTO of la_fundamental is
	
begin
		-- Processo que gera o clock de saída de 440Hz.
		prescaler: process(CLK,RST,ENA)
			variable cnt: integer range 0 to FATOR + 5 := 0;
			variable CLK440 : std_logic := '0';
			
begin
			
	if RST = '0' then 
		CLK440 := '0';
		cnt := 0;
			
	elsif ENA = '0' then
	   if rising_edge(CLK) then
			cnt := cnt + 1;
				
			if cnt = FATOR then
				cnt := 0;
				CLK440 := not CLK440;
			end if;
			
		end if;	
		
	else 
		CLK440 := '0';
	end if;
	
	BUZR <= CLK440;  
	
end process;


end architecture COMPORTAMENTO;